diff -ruN ../nakedmudv3.7.9/src/scripts/trighooks.c src/scripts/trighooks.c
--- ../nakedmudv3.7.9/src/scripts/trighooks.c	2009-03-02 01:08:22.000000000 -0500
+++ src/scripts/trighooks.c	2009-04-01 14:02:06.000000000 -0400
@@ -23,6 +23,8 @@
 #include "pyobj.h"
 #include "pyroom.h"
 #include "pyexit.h"
+#include "pymudsys.h"
+#include "trighooks.h"
 
 
 
@@ -30,17 +32,15 @@
 // local datastructures and defines
 //*****************************************************************************
 
-// values for figuring out what "me" and optional variables are in gen_do_trig
-#define VARTYPE_CHAR      0
-#define VARTYPE_OBJ       1
-#define VARTYPE_ROOM      2
+// a table matching trigger types to what they can attach to (obj, mob, room)
+HASHTABLE *tedit_opts = NULL;
 
 // used for providing additional variables to gen_do_trig that are not standard
-typedef struct {
+struct opt_var {
   char *name;
   void *data;
   int   type;
-} OPT_VAR;
+};
 
 OPT_VAR *newOptVar(const char *name, void *data, int type) {
   OPT_VAR *var = malloc(sizeof(OPT_VAR));
@@ -55,6 +55,16 @@
   free(var);
 }
 
+HASHTABLE *get_tedit_opts(void) {
+  return tedit_opts;
+}
+
+void register_tedit_opt(const char *type, const char *desc) {
+  if(tedit_opts == NULL)
+    tedit_opts = newHashtable();
+  hashPut(tedit_opts, type, strdupsafe(desc));
+}
+
 
 
 //*****************************************************************************
@@ -114,9 +124,9 @@
   if(me) {
     PyObject *pyme = NULL;
     switch(me_type) {
-    case VARTYPE_CHAR:  pyme = charGetPyForm(me); break;
-    case VARTYPE_OBJ:   pyme = objGetPyForm(me);  break;
-    case VARTYPE_ROOM:  pyme = roomGetPyForm(me); break;
+    case TRIGVAR_CHAR:  pyme = charGetPyForm(me); break;
+    case TRIGVAR_OBJ:   pyme = objGetPyForm(me);  break;
+    case TRIGVAR_ROOM:  pyme = roomGetPyForm(me); break;
     }
     PyDict_SetItemString(dict, "me", pyme);
     listPut(varnames, strdup("me"));
@@ -131,9 +141,9 @@
     ITERATE_LIST(opt, opt_i) {
       pyopt = NULL;
       switch(opt->type) {
-      case VARTYPE_CHAR:  pyopt = charGetPyForm(opt->data); break;
-      case VARTYPE_OBJ:   pyopt = objGetPyForm(opt->data);  break;
-      case VARTYPE_ROOM:  pyopt = roomGetPyForm(opt->data); break;
+      case TRIGVAR_CHAR:  pyopt = charGetPyForm(opt->data); break;
+      case TRIGVAR_OBJ:   pyopt = objGetPyForm(opt->data);  break;
+      case TRIGVAR_ROOM:  pyopt = roomGetPyForm(opt->data); break;
       }
       PyDict_SetItemString(dict, opt->name, pyopt);
       listPut(varnames, strdup(opt->name));
@@ -157,174 +167,31 @@
   Py_XDECREF(dict);
 }
 
-
-//
-// handles all of a character's triggers
-void do_char_trigs(CHAR_DATA *ch, const char *type, void *thing, void *arg) {
-  if(ch == NULL)
-    return;
-
-  if(listSize(charGetTriggers(ch)) > 0) {
-    // first, build a list of all our triggers of this type
-    LIST           *trigs = newList();
-    LIST_ITERATOR *trig_i = newListIterator(charGetTriggers(ch));
-    const char       *key = NULL;
-    TRIGGER_DATA    *trig = NULL;
-    ITERATE_LIST(key, trig_i) {
-      if((trig = worldGetType(gameworld, "trigger", key)) != NULL &&
-	 !strcasecmp(triggerGetType(trig), type))
-	listPut(trigs, trig);
-    } deleteListIterator(trig_i);
-
-    // did we find any triggers?
-    if(listSize(trigs) > 0) {
-      trig_i = newListIterator(trigs);
-      ITERATE_LIST(trig, trig_i) {
-	if(!strcasecmp(type, "speech"))
-	  gen_do_trig(trig,ch,VARTYPE_CHAR,thing,NULL,NULL,NULL,NULL,arg,NULL);
-	else if(!strcasecmp(type, "look"))
-	  gen_do_trig(trig,ch,VARTYPE_CHAR,thing,NULL,NULL,NULL,NULL,NULL,NULL);
-	else if(!strcasecmp(type, "self_exit"))
-	  gen_do_trig(trig,ch,VARTYPE_CHAR,NULL,NULL,NULL,thing,NULL,NULL,NULL);
-	else if(!strcasecmp(type, "self_enter"))
-	  gen_do_trig(trig,ch,VARTYPE_CHAR,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
-	else if(!strcasecmp(type, "enter"))
-	  gen_do_trig(trig,ch,VARTYPE_CHAR,thing,NULL,NULL,NULL,NULL,NULL,NULL);
-	else if(!strcasecmp(type, "exit"))
-	  gen_do_trig(trig,ch,VARTYPE_CHAR,thing,NULL,NULL,arg,NULL,NULL,NULL);
-	else if(!strcasecmp(type, "greet"))
-	  gen_do_trig(trig,ch,VARTYPE_CHAR,thing,NULL,NULL,NULL,NULL,NULL,NULL);
-	else if(!strcasecmp(type, "give"))
-	  gen_do_trig(trig,ch,VARTYPE_CHAR,thing,arg,NULL,NULL,NULL,NULL,NULL);
-	else if(!strcasecmp(type, "receive"))
-	  gen_do_trig(trig,ch,VARTYPE_CHAR,thing,arg,NULL,NULL,NULL,NULL,NULL);
-	else if(!strcasecmp(type, "wear"))
-	  gen_do_trig(trig,ch,VARTYPE_CHAR,NULL,thing,NULL,NULL,NULL,NULL,NULL);
-	else if(!strcasecmp(type, "remove"))
-	  gen_do_trig(trig,ch,VARTYPE_CHAR,NULL,thing,NULL,NULL,NULL,NULL,NULL);
-	else if(!strcasecmp(type, "to_game"))
-	  gen_do_trig(trig,ch,VARTYPE_CHAR,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
-	else {
-	  log_string("Unrecognized trigger type %s attached to %s, uid %d.\r\n",
-		     type, charGetClass(ch), charGetUID(ch));
-	}
-      } deleteListIterator(trig_i);
-    }
-    
-    // clean up our mess
-    deleteList(trigs);
-  }
-}
-
 //
-// handles all of an object's triggers
-void do_obj_trigs(OBJ_DATA *obj, const char *type, void *thing, void *arg) {
-  if(obj == NULL)
-    return;
-
-  if(listSize(objGetTriggers(obj)) > 0) {
-    // first, build a list of all our triggers of this type
-    LIST           *trigs = newList();
-    LIST_ITERATOR *trig_i = newListIterator(objGetTriggers(obj));
-    const char       *key = NULL;
-    TRIGGER_DATA    *trig = NULL;
-    ITERATE_LIST(key, trig_i) {
-      if((trig = worldGetType(gameworld, "trigger", key)) != NULL &&
-	 !strcasecmp(triggerGetType(trig), type))
-	listPut(trigs, trig);
-    } deleteListIterator(trig_i);
-
-    // did we find any triggers?
-    if(listSize(trigs) > 0) {
-      trig_i = newListIterator(trigs);
-      ITERATE_LIST(trig, trig_i) {
-	if(!strcasecmp(type, "give")) {
-	  // set up the optional "receiver" variable
-	  LIST *opts = newList();
-	  listPut(opts, newOptVar("recv", arg, VARTYPE_CHAR));
-	  gen_do_trig(trig,obj,VARTYPE_OBJ,thing,NULL,NULL,NULL,NULL,NULL,opts);
-	  deleteListWith(opts, deleteOptVar);
-	}
-	else if(!strcasecmp(type, "get"))
-	  gen_do_trig(trig,obj,VARTYPE_OBJ,thing,NULL,NULL,NULL,NULL,NULL,NULL);
-	else if(!strcasecmp(type, "drop"))
-	  gen_do_trig(trig,obj,VARTYPE_OBJ,thing,NULL,NULL,NULL,NULL,NULL,NULL);
-	else if(!strcasecmp(type, "wear"))
-	  gen_do_trig(trig,obj,VARTYPE_OBJ,thing,NULL,NULL,NULL,NULL,NULL,NULL);
-	else if(!strcasecmp(type, "remove"))
-	  gen_do_trig(trig,obj,VARTYPE_OBJ,thing,NULL,NULL,NULL,NULL,NULL,NULL);
-	else if(!strcasecmp(type, "open"))
-	  gen_do_trig(trig,obj,VARTYPE_OBJ,thing,NULL,NULL,NULL,NULL,NULL,NULL);
-	else if(!strcasecmp(type, "close"))
-	  gen_do_trig(trig,obj,VARTYPE_OBJ,thing,NULL,NULL,NULL,NULL,NULL,NULL);
-	else if(!strcasecmp(type, "look"))
-	  gen_do_trig(trig,obj,VARTYPE_OBJ,thing,NULL,NULL,NULL,NULL,NULL,NULL);
-	else if(!strcasecmp(type, "to_game"))
-	  gen_do_trig(trig,obj,VARTYPE_OBJ,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
-	else {
-	  log_string("Unrecognized trigger type %s attached to %s, uid %d.\r\n",
-		     type, objGetClass(obj), objGetUID(obj));
-	}
-      } deleteListIterator(trig_i);
-    }
-
-    // clean up our mess
-    deleteList(trigs);
-  }
-}
+// generalized function for running all triggers of a specified type.
+void gen_do_trigs(void *me, int me_type, const char *type,
+		  CHAR_DATA *ch,OBJ_DATA *obj, ROOM_DATA *room, EXIT_DATA *exit,
+		  const char *command, const char *arg, LIST *optional) {
+  // find our list of triggers
+  LIST *trig_keys = NULL;
+  if(me_type == TRIGVAR_CHAR)
+    trig_keys = charGetTriggers(me);
+  else if(me_type == TRIGVAR_OBJ)
+    trig_keys = objGetTriggers(me);
+  else if(me_type == TRIGVAR_ROOM)
+    trig_keys = roomGetTriggers(me);
 
-//
-// handles all of a room's triggers
-void do_room_trigs(ROOM_DATA *rm, const char *type, void *thing, void *arg){
-  if(rm == NULL)
+  if(trig_keys == NULL || listSize(trig_keys) == 0)
     return;
-
-  if(listSize(roomGetTriggers(rm)) > 0) {
-    // first, build a list of all our triggers of this type
-    LIST           *trigs = newList();
-    LIST_ITERATOR *trig_i = newListIterator(roomGetTriggers(rm));
-    const char       *key = NULL;
-    TRIGGER_DATA    *trig = NULL;
-    ITERATE_LIST(key, trig_i) {
-      if((trig = worldGetType(gameworld, "trigger", key)) != NULL &&
-	 !strcasecmp(triggerGetType(trig), type))
-	listPut(trigs, trig);
-    } deleteListIterator(trig_i);
-
-    // did we find any triggers?
-    if(listSize(trigs) > 0) {
-      trig_i = newListIterator(trigs);
-      ITERATE_LIST(trig, trig_i) {
-	if(!strcasecmp(type, "get"))
-	  gen_do_trig(trig,rm,VARTYPE_ROOM,thing,arg,NULL,NULL,NULL,NULL,NULL);
-	else if(!strcasecmp(type, "drop"))
-	  gen_do_trig(trig,rm,VARTYPE_ROOM,thing,arg,NULL,NULL,NULL,NULL,NULL);
-	else if(!strcasecmp(type, "enter"))
-	  gen_do_trig(trig,rm,VARTYPE_ROOM,thing,NULL,NULL,NULL,NULL,NULL,NULL);
-	else if(!strcasecmp(type, "exit"))
-	  gen_do_trig(trig,rm,VARTYPE_ROOM,thing,NULL,NULL,arg,NULL,NULL,NULL);
- 	else if(!strcasecmp(type, "look"))
- 	  gen_do_trig(trig,rm,VARTYPE_ROOM,thing,NULL,NULL,NULL,NULL,NULL,NULL);
-	else if(!strcasecmp(type, "speech"))
-	  gen_do_trig(trig,rm,VARTYPE_ROOM,thing,NULL,NULL,NULL,NULL,arg,NULL);
-	else if(!strcasecmp(type, "reset"))
-	  gen_do_trig(trig,rm,VARTYPE_ROOM,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
-	else if(!strcasecmp(type, "open"))
-	  gen_do_trig(trig,rm,VARTYPE_ROOM,thing,NULL,NULL,arg,NULL,NULL,NULL);
- 	else if(!strcasecmp(type, "close"))
- 	  gen_do_trig(trig,rm,VARTYPE_ROOM,thing,NULL,NULL,arg,NULL,NULL,NULL);
- 	else if(!strcasecmp(type, "to_game"))
- 	  gen_do_trig(trig,rm,VARTYPE_ROOM,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
-	else {
-	  log_string("Unrecognized trigger type %s attached to %s, uid %d.\r\n",
-		     type, roomGetClass(rm), roomGetUID(rm));
-	}
-      } deleteListIterator(trig_i);
-    }
-    
-    // clean up our mess
-    deleteList(trigs);
-  }
+  
+  char        *trig_key = NULL;
+  LIST_ITERATOR *trig_i = newListIterator(trig_keys);
+  TRIGGER_DATA    *trig = NULL;
+  ITERATE_LIST(trig_key, trig_i) {
+    if((trig = worldGetType(gameworld, "trigger", trig_key)) != NULL &&
+       !strcasecmp(triggerGetType(trig), type))
+      gen_do_trig(trig,me,me_type,ch,obj,room,exit,command,arg,optional);
+  } deleteListIterator(trig_i);
 }
 
 
@@ -338,9 +205,15 @@
   OBJ_DATA   *obj = NULL;
   hookParseInfo(info, &ch, &recv, &obj);
 
-  do_char_trigs(ch,   "give",    recv, obj);
-  do_char_trigs(recv, "receive", ch,   obj);
-  do_obj_trigs (obj,  "give",    ch,  recv);
+  gen_do_trigs(ch,TRIGVAR_CHAR,"give",recv,obj,NULL,NULL,NULL,NULL,NULL);
+  gen_do_trigs(recv,TRIGVAR_CHAR,"receive",ch,obj,NULL,NULL,NULL,NULL,NULL);
+
+  LIST *opts = newList();
+  listPut(opts, newOptVar("vict", recv, TRIGVAR_CHAR));
+  gen_do_trigs(obj,TRIGVAR_OBJ,"give",ch,NULL,NULL,NULL,NULL,NULL,opts);
+
+  // garbage collection
+  deleteListWith(opts, deleteOptVar);
 }
 
 void do_get_trighooks(const char *info) {
@@ -348,17 +221,16 @@
   OBJ_DATA *obj = NULL;
   hookParseInfo(info, &ch, &obj);
 
-  do_obj_trigs (obj,             "get", ch, NULL);
-  do_room_trigs(charGetRoom(ch), "get", ch, obj);
+  gen_do_trigs(obj,TRIGVAR_OBJ,"get",ch,NULL,NULL,NULL,NULL,NULL,NULL);
+  gen_do_trigs(charGetRoom(ch),TRIGVAR_ROOM,"get",ch,obj,NULL,NULL,NULL,NULL,NULL);
 }
 
 void do_drop_trighooks(const char *info) {
   CHAR_DATA *ch = NULL;
   OBJ_DATA *obj = NULL;
   hookParseInfo(info, &ch, &obj);
-
-  do_obj_trigs (obj,             "drop", ch, NULL);
-  do_room_trigs(charGetRoom(ch), "drop", ch,  obj);
+  gen_do_trigs(obj,TRIGVAR_OBJ,"drop",ch,NULL,NULL,NULL,NULL,NULL,NULL);
+  gen_do_trigs(charGetRoom(ch),TRIGVAR_ROOM,"drop",ch,obj,NULL,NULL,NULL,NULL,NULL);
 }
 
 void do_enter_trighooks(const char *info) {
@@ -370,10 +242,10 @@
   CHAR_DATA       *mob = NULL;
   ITERATE_LIST(mob, mob_i) {
     if(ch != mob)
-      do_char_trigs(mob, "enter", ch, NULL);
+      gen_do_trigs(mob,TRIGVAR_CHAR,"enter",ch,NULL,NULL,NULL,NULL,NULL,NULL);
   } deleteListIterator(mob_i);
-  do_room_trigs(room, "enter", ch, NULL);
-  do_char_trigs(ch,   "self_enter", NULL, NULL);
+  gen_do_trigs(room,TRIGVAR_ROOM,"enter",ch,NULL,NULL,NULL,NULL,NULL,NULL);
+  gen_do_trigs(ch,TRIGVAR_CHAR,"self enter",NULL,NULL,NULL,NULL,NULL,NULL,NULL);
 }
 
 void do_exit_trighooks(const char *info) {
@@ -386,10 +258,10 @@
   CHAR_DATA       *mob = NULL;
   ITERATE_LIST(mob, mob_i) {
     if(ch != mob)
-      do_char_trigs(mob, "exit", ch, exit);
+      gen_do_trigs(mob,TRIGVAR_CHAR,"exit",ch,NULL,NULL,exit,NULL,NULL,NULL);
   } deleteListIterator(mob_i);
-  do_room_trigs(room, "exit", ch,   exit);
-  do_char_trigs(ch,   "self_exit", exit, NULL);
+  gen_do_trigs(room,TRIGVAR_ROOM,"exit",ch,NULL,NULL,exit,NULL,NULL,NULL);
+  gen_do_trigs(ch,TRIGVAR_CHAR,"self exit",NULL,NULL,NULL,exit,NULL,NULL,NULL);
 }
 
 void do_ask_trighooks(const char *info) {
@@ -397,8 +269,10 @@
   CHAR_DATA *listener = NULL;
   char        *speech = NULL;
   hookParseInfo(info, &ch, &listener, &speech);
-  do_char_trigs(listener, "speech", ch, speech);
-  if(speech) free(speech);
+  gen_do_trigs(listener,TRIGVAR_CHAR,"speech",ch,NULL,NULL,NULL,NULL,speech,NULL);
+
+  // garbage collection
+  free(speech);
 }
 
 void do_say_trighooks(const char *info) {
@@ -410,34 +284,35 @@
   CHAR_DATA       *mob = NULL;
   ITERATE_LIST(mob, mob_i) {
     if(ch != mob)
-      do_char_trigs(mob, "speech", ch, speech);
+     gen_do_trigs(mob,TRIGVAR_CHAR,"speech",ch,NULL,NULL,NULL,NULL,speech,NULL);
   } deleteListIterator(mob_i);
-  do_room_trigs(charGetRoom(ch), "speech", ch, speech);
-  if(speech) free(speech);
+  gen_do_trigs(charGetRoom(ch),TRIGVAR_ROOM,"speech",ch,NULL,NULL,NULL,NULL,speech,NULL);
+
+  // garbage collection
+  free(speech);
 }
 
 void do_greet_trighooks(const char *info) {
   CHAR_DATA      *ch = NULL;
   CHAR_DATA *greeted = NULL;
   hookParseInfo(info, &ch, &greeted);
-  do_char_trigs(greeted, "greet", ch, NULL);
+  gen_do_trigs(greeted,TRIGVAR_CHAR,"greet",ch,NULL,NULL,NULL,NULL,NULL,NULL);
 }
 
 void do_wear_trighooks(const char *info) {
   CHAR_DATA *ch = NULL;
   OBJ_DATA *obj = NULL;
   hookParseInfo(info, &ch, &obj);
-
-  do_char_trigs(ch,  "wear", obj, NULL);
-  do_obj_trigs (obj, "wear", ch,  NULL);
+  gen_do_trigs(ch,TRIGVAR_CHAR,"wear",NULL,obj,NULL,NULL,NULL,NULL,NULL);
+  gen_do_trigs(obj,TRIGVAR_OBJ,"wear",ch,NULL,NULL,NULL,NULL,NULL,NULL);
 }
 
 void do_remove_trighooks(const char *info) {
   CHAR_DATA *ch = NULL;
   OBJ_DATA *obj = NULL;
   hookParseInfo(info, &ch, &obj);
-  do_char_trigs(ch,  "remove", obj, NULL);
-  do_obj_trigs (obj, "remove", ch,  NULL);
+  gen_do_trigs(ch,TRIGVAR_CHAR,"remove",NULL,obj,NULL,NULL,NULL,NULL,NULL);
+  gen_do_trigs(obj,TRIGVAR_OBJ,"remove",ch,NULL,NULL,NULL,NULL,NULL,NULL);
 }
 
 void do_reset_trighooks(const char *info) {
@@ -451,7 +326,8 @@
   ROOM_DATA      *room = NULL;
   ITERATE_LIST(name, res_i) {
     room = worldGetRoom(gameworld, get_fullkey(name, locale));
-    if(room != NULL) do_room_trigs(room, "reset", NULL, NULL);
+    if(room != NULL)
+     gen_do_trigs(room,TRIGVAR_ROOM,"reset",NULL,NULL,NULL,NULL,NULL,NULL,NULL);
   } deleteListIterator(res_i);
 
   // garbage collection
@@ -462,67 +338,67 @@
   CHAR_DATA *ch = NULL;
   EXIT_DATA *ex = NULL;
   hookParseInfo(info, &ch, &ex);
-  do_room_trigs(charGetRoom(ch), "open", ch, ex);
+  gen_do_trigs(charGetRoom(ch),TRIGVAR_ROOM,"open",ch,NULL,NULL,ex,NULL,NULL,NULL);
 }
 
 void do_open_obj_trighooks(const char *info) {
   CHAR_DATA *ch = NULL;
   OBJ_DATA *obj = NULL;
   hookParseInfo(info, &ch, &obj);
-  do_obj_trigs(obj, "open", ch, NULL);
+  gen_do_trigs(obj,TRIGVAR_OBJ,"open",ch,NULL,NULL,NULL,NULL,NULL,NULL);
 }
 
 void do_close_door_trighooks(const char *info) {
   CHAR_DATA *ch = NULL;
   EXIT_DATA *ex = NULL;
   hookParseInfo(info, &ch, &ex);
-  do_room_trigs(charGetRoom(ch), "close", ch, ex);
+  gen_do_trigs(charGetRoom(ch),TRIGVAR_ROOM,"close",ch,NULL,NULL,ex,NULL,NULL,NULL);
 }
 
 void do_close_obj_trighooks(const char *info) {
   CHAR_DATA *ch = NULL;
   OBJ_DATA *obj = NULL;
   hookParseInfo(info, &ch, &obj);
-  do_obj_trigs(obj, "close", ch, NULL);
+  gen_do_trigs(obj,TRIGVAR_OBJ,"close",ch,NULL,NULL,NULL,NULL,NULL,NULL);
 }
 
 void do_look_at_obj_trighooks(const char *info) {
   OBJ_DATA     *obj = NULL;
   CHAR_DATA *looker = NULL;
   hookParseInfo(info, &obj, &looker);
-  do_obj_trigs(obj, "look", looker, NULL);
+  gen_do_trigs(obj,TRIGVAR_OBJ,"look",looker,NULL,NULL,NULL,NULL,NULL,NULL);
 }
 
 void do_look_at_room_trighooks(const char *info) {
   ROOM_DATA   *room = NULL;
   CHAR_DATA *looker = NULL;
   hookParseInfo(info, &room, &looker);
-  do_room_trigs(room, "look", looker, NULL);
+  gen_do_trigs(room,TRIGVAR_ROOM,"look",looker,NULL,NULL,NULL,NULL,NULL,NULL);
 }
 
 void do_look_at_char_trighooks(const char *info) {
   CHAR_DATA     *ch = NULL;
   CHAR_DATA *looker = NULL;
   hookParseInfo(info, &ch, &looker);
-  do_char_trigs(ch, "look", looker, NULL);
+  gen_do_trigs(ch,TRIGVAR_CHAR,"look",looker,NULL,NULL,NULL,NULL,NULL,NULL);
 }
 
 void do_obj_to_game_trighooks(const char *info) {
   OBJ_DATA *obj = NULL;
   hookParseInfo(info, &obj);
-  do_obj_trigs(obj, "to_game", obj, NULL);
+  gen_do_trigs(obj,TRIGVAR_OBJ,"to_game",NULL,NULL,NULL,NULL,NULL,NULL,NULL);
 }
 
 void do_char_to_game_trighooks(const char *info) {
   CHAR_DATA *ch = NULL;
   hookParseInfo(info, &ch);
-  do_char_trigs(ch, "to_game", ch, NULL);
+  gen_do_trigs(ch, TRIGVAR_CHAR,"to_game",NULL,NULL,NULL,NULL,NULL,NULL,NULL);
 }
 
 void do_room_to_game_trighooks(const char *info) {
   ROOM_DATA *rm = NULL;
   hookParseInfo(info, &rm);
-  do_room_trigs(rm, "to_game", rm, NULL);
+  gen_do_trigs(rm,TRIGVAR_ROOM,"to_game",NULL,NULL,NULL,NULL,NULL,NULL,NULL);
 }
 
 
@@ -553,4 +429,23 @@
   hookAdd("obj_to_game",    do_obj_to_game_trighooks);
   hookAdd("char_to_game",   do_char_to_game_trighooks);
   hookAdd("room_to_game",   do_room_to_game_trighooks);
+
+  // add our trigger displays
+  register_tedit_opt("speech",         "mob, room" );
+  register_tedit_opt("greet",          "mob"       );
+  register_tedit_opt("enter",          "mob, room" );
+  register_tedit_opt("exit",           "mob, room" );
+  register_tedit_opt("self enter",     "mob"       ),
+  register_tedit_opt("self exit",      "mob"       );
+  register_tedit_opt("drop",           "obj, room" );
+  register_tedit_opt("get",            "obj, room" );
+  register_tedit_opt("give",           "obj, mob"  );
+  register_tedit_opt("receive",        "mob"       );
+  register_tedit_opt("wear",           "obj, mob"  );
+  register_tedit_opt("remove",         "obj, mob"  );
+  register_tedit_opt("reset",          "room"      );
+  register_tedit_opt("look",           "obj, mob, room" );
+  register_tedit_opt("open",           "obj, room" );
+  register_tedit_opt("close",          "obj, room" );
+  register_tedit_opt("to_game",        "obj, mob, room" );
 }
diff -ruN ../nakedmudv3.7.9/src/scripts/trighooks.h src/scripts/trighooks.h
--- ../nakedmudv3.7.9/src/scripts/trighooks.h	2005-11-14 00:28:06.000000000 -0500
+++ src/scripts/trighooks.h	2009-04-01 14:02:06.000000000 -0400
@@ -5,8 +5,7 @@
 // trighooks.h
 //
 // Triggers attach on to rooms, objects, and mobiles as hooks. When a hook
-// event occurs, all of the triggers of the right type will run. This header is
-// just to allow scripts to initialize the hooks into the game. The init 
+// event occurs, all of the triggers of the right type will run. The init 
 // function here should not be touched by anything other than scripts.c
 //
 //*****************************************************************************
@@ -15,5 +14,41 @@
 // called when init_scripts() is run
 void init_trighooks(void);
 
-#endif // TRIGHOOKS_H
+//
+// values for figuring out what "me" and optional variables are in gen_do_trigs
+#define TRIGVAR_CHAR      0
+#define TRIGVAR_OBJ       1
+#define TRIGVAR_ROOM      2
+
+//
+// structure for defining extra variables when calling gen_do_trigs
+typedef struct opt_var OPT_VAR;
+
+//
+// create and delete optional variables for use with gen_do_trigs
+OPT_VAR *newOptVar(const char *name, void *data, int type);
+void  deleteOptVar(OPT_VAR *var);
 
+//
+// generalized function for running all triggers of a specified type. First
+// argument is the thing tirggers are being run for. Me must be a character,
+// object, or room that owns the triggers. me_type is an integer value that
+// specifies the owner. Type is the class of triggers to be run. Other variables
+// appear as the same name in the trigger. Each can be NULL. If other variables
+// are needed, a list of optionals can be provided, which must be deleted after
+// use
+void gen_do_trigs(void *me, int me_type, const char *type,
+		  CHAR_DATA *ch,OBJ_DATA *obj, ROOM_DATA *room, EXIT_DATA *exit,
+		  const char *cmd, const char *arg, LIST *optional);
+
+//
+// the trigger edit (tedit) menu displays a list of possible trigger types
+// to choose from. That list can be extended by calling this function. desc
+// should be a comma-separated list of things the trigger can be attached to
+// (obj, mob, room, in that order)
+void register_tedit_opt(const char *type, const char *desc); 
+
+// returns a table of the available tedit opts
+HASHTABLE *get_tedit_opts(void);
+
+#endif // TRIGHOOKS_H
diff -ruN ../nakedmudv3.7.9/src/socket.c src/socket.c
--- ../nakedmudv3.7.9/src/socket.c	2009-03-02 01:00:40.000000000 -0500
+++ src/socket.c	2009-03-16 03:17:41.000000000 -0400
@@ -48,7 +48,9 @@
   ACCOUNT_DATA  * account;
   char          * hostname;
   char            inbuf[MAX_INPUT_LEN];
-  char            next_command[MAX_BUFFER];
+  BUFFER        * next_command;
+  BUFFER        * iac_sequence;
+  // char            next_command[MAX_BUFFER];
   bool            cmd_read;
   bool            bust_prompt;
   bool            closed;
@@ -440,139 +442,130 @@
   bufferCat(dsock->outbuf, txt);
 }
 
+//
+// read an IAC sequence from the socket's input buffer. When we hit a
+// termination point, send a hook and clear he buffer. Return how many
+// characters to skip ahead in the input handler
+int read_iac_sequence(SOCKET_DATA *dsock, int start) {
+  // are we doing subnegotiation?
+  bool subneg = strchr(bufferString(dsock->iac_sequence), SB) != NULL;
+  int       i = start;
+  bool   done = FALSE;
+
+  for(; dsock->inbuf[i] != '\0'; i++) {
+    // are we looking for IAC?
+    if(bufferLength(dsock->iac_sequence) == 0) {
+      // Oops! Something is broken
+      if(dsock->inbuf[i] != (signed char) IAC)
+	return 0;
+      else
+	bufferCatCh(dsock->iac_sequence, IAC);
+    }
+
+    // are we looking for a command?
+    else if(bufferLength(dsock->iac_sequence) == 1) {
+      // did we find subnegotiation?
+      if(dsock->inbuf[i] == (signed char) SB) {
+	bufferCatCh(dsock->iac_sequence, dsock->inbuf[i]);
+	subneg = TRUE;
+      }
+
+      // basic three-character command
+      else if(dsock->inbuf[i] == (signed char) WILL || 
+	      dsock->inbuf[i] == (signed char) WONT || 
+	      dsock->inbuf[i] == (signed char) DO   || 
+	      dsock->inbuf[i] == (signed char) DONT)
+	bufferCatCh(dsock->iac_sequence, dsock->inbuf[i]);
+
+      // something went wrong
+      else {
+	bufferClear(dsock->iac_sequence);
+	return 2;
+      }
+    }
+    
+    // are we doing subnegotiation?
+    else if(subneg) {
+      int       last_i = bufferLength(dsock->iac_sequence) - 2;
+      signed char last = bufferString(dsock->iac_sequence)[last_i];
+      bufferCatCh(dsock->iac_sequence, dsock->inbuf[i]);
+
+      // have hit the end of the subnegotiation? Break out if so
+      if(last == (signed char) IAC && dsock->inbuf[i] == (signed char) SE) {
+	done = TRUE;
+	break;
+      }
+    }
+
+    // this is the end
+    else {
+      bufferCatCh(dsock->iac_sequence, dsock->inbuf[i]);
+      done = TRUE;
+      break;
+    }
+  }
+  
+  int len = i - start + (dsock->inbuf[i] == '\0' ? 0 : 1);
+
+  // broadcast the message we parsed, and prepare for the next sequence
+  if(done == TRUE) {
+    hookRun("receive_iac", 
+	    hookBuildInfo("sk str", dsock,bufferString(dsock->iac_sequence)));
+    bufferClear(dsock->iac_sequence);
+  }
+  return len;
+}
 
 void next_cmd_from_buffer(SOCKET_DATA *dsock) {
   // do we have stuff in our input list? If so, use that instead of inbuf
   dsock->cmd_read = FALSE;
   if(listSize(dsock->input) > 0) {
     char *cmd = listPop(dsock->input);
-    strncpy(dsock->next_command, cmd, MAX_BUFFER);
+    bufferClear(dsock->next_command);
+    bufferCat(dsock->next_command, cmd);
     dsock->cmd_read    = TRUE;
     dsock->bust_prompt = TRUE;
     free(cmd);
   }
   else {
-    int size = 0, i = 0, j = 0; //, telopt = 0;
-    static char iacopt[MAX_BUFFER];
-    bool found_iac = FALSE;
-    iacopt[0] = '\0';
-    
-    // if theres already a command ready, we return
-    if(dsock->next_command[0] != '\0')
-      return;
-    
-    // if there is nothing pending, then return
-    if(dsock->inbuf[0] == '\0')
-      return;
-
-    // check how long the next command is
-    while(dsock->inbuf[size] != '\0' && 
-	  dsock->inbuf[size] != '\n' && dsock->inbuf[size] != '\r')
-      size++;
-
-    /* we only deal with real commands */
-    // I'm not really sure what this means, or does! -- Geoff
-    if(dsock->inbuf[size] == '\0')
-      return;
-
-    // copy the next command into next_command
-    for(; i < size; i++) {
-      // we have a system command. Try to parse it out
-      if(dsock->inbuf[i] == (signed char) IAC) {
-	int iac_i       = 0;
-	iacopt[iac_i++] = (signed char) dsock->inbuf[i++];
-	
-	// IAC escape sequence: IAC IAC
-	if(dsock->inbuf[i] == (signed char) IAC)
-	  iacopt[iac_i++] = (signed char) dsock->inbuf[i];
-	
-	// subnegotiation, read until the end of the sequence
-	if(dsock->inbuf[i] == (signed char) SB) {
-	  while(dsock->inbuf[i] != (signed char) SE)
-	    iacopt[iac_i++] = (signed char) dsock->inbuf[i++];
-	  iacopt[iac_i++] = (signed char) dsock->inbuf[i];
-	}
-
-	// basic three-character command
-	else if(dsock->inbuf[i] == (signed char) WILL || 
-		dsock->inbuf[i] == (signed char) WONT || 
-		dsock->inbuf[i] == (signed char) DO   || 
-		dsock->inbuf[i] == (signed char) DONT) {
-	  iacopt[iac_i++] = (signed char) dsock->inbuf[i++];
-	  iacopt[iac_i++] = (signed char) dsock->inbuf[i];
-	}
-	
-	// not sure what happened here! Something got busted in transit
-	else {
-	  iacopt[iac_i++] = dsock->inbuf[i];
-	}
-
-	// close off the command
-	iacopt[iac_i++] = '\0';
-
-	// did we find an IAC command? Notify the world!
-	if(*iacopt) {
-	  found_iac = TRUE;
-	  hookRun("receive_iac", hookBuildInfo("sk str", dsock, iacopt));
-	  //*iacopt = '\0';
-	}
-      }
-      
-      else if(isprint(dsock->inbuf[i]) && isascii(dsock->inbuf[i])) {
-	dsock->next_command[j++] = dsock->inbuf[i];
-      }
-      else {
-	// log_string("BAD CHARACTER %d", (unsigned int)dsock->inbuf[i]); 
-      }
+    int i = 0, cmd_end = -1;
 
-      /*
-       * THE OLD HANDLER
-       *
-      if(dsock->inbuf[i] == (signed char) IAC)
-	telopt = 1;
-      else if(telopt == 1 && (dsock->inbuf[i] == (signed char) DO || 
-			      dsock->inbuf[i] == (signed char) DONT))
-	telopt = 2;
-    
-      // check for compression format
-      else if(telopt == 2) {
-	unsigned char compress_opt = dsock->inbuf[i];
-	telopt = 0;
-	
-	// check if we're using a valid compression
-	if(compress_opt == TELOPT_COMPRESS || compress_opt == TELOPT_COMPRESS2){
-	  // start compressing
-	  if(dsock->inbuf[i-1] == (signed char) DO)                  
-	    compressStart(dsock, compress_opt);
-	  // stop compressing
-	  else if(dsock->inbuf[i-1] == (signed char) DONT)
-	    compressEnd(dsock, compress_opt, FALSE);
-	}
+    // are we building an IAC command? Try to continue it
+    if(bufferLength(dsock->iac_sequence) > 0)
+      i += read_iac_sequence(dsock, 0);
+
+    // copy over characters until we hit a newline, an IAC command, or \0
+    for(; dsock->inbuf[i] != '\0' && cmd_end < 0; i++) {
+      switch(dsock->inbuf[i]) {
+      default:
+	// append us to the command
+	bufferCatCh(dsock->next_command, dsock->inbuf[i]);
+	break;
+      case '\n':
+	// command end found
+	cmd_end = ++i;
+      case '\r':
+	// ignore \r ... only pay attention to \n
+	break;
+      case (signed char) IAC:
+	i += read_iac_sequence(dsock, i) - 1;
+	break;
       }
-      else if(isprint(dsock->inbuf[i]) && isascii(dsock->inbuf[i])) {
-	dsock->next_command[j++] = dsock->inbuf[i];
-      }
-      */
+      if(cmd_end >= 0)
+	break;
     }
+
+    // move the context of inbuf down
+    int begin = 0;
+    while(dsock->inbuf[i] != '\0')
+      dsock->inbuf[begin++] = dsock->inbuf[i++];
+    dsock->inbuf[begin] = '\0';
     
-    dsock->next_command[j] = '\0';
-    
-    // skip forward to the next line
-    while(dsock->inbuf[size] == '\n' || dsock->inbuf[size] == '\r') {
+    // did we find a command?
+    if(cmd_end >= 0) {
       dsock->cmd_read    = TRUE;
       dsock->bust_prompt = TRUE;
-      size++;
-    }
-    
-    // use i as a static pointer
-    i = size;
-    
-    // move the context of inbuf down
-    while(dsock->inbuf[size] != '\0') {
-      dsock->inbuf[size - i] = dsock->inbuf[size];
-      size++;
     }
-    dsock->inbuf[size - i] = '\0';
   }
 }
 
@@ -635,6 +628,8 @@
   if(sock->page_string)   free(sock->page_string);
   if(sock->text_editor)   deleteBuffer(sock->text_editor);
   if(sock->outbuf)        deleteBuffer(sock->outbuf);
+  if(sock->next_command)  deleteBuffer(sock->next_command);
+  if(sock->iac_sequence)  deleteBuffer(sock->iac_sequence);
   if(sock->input_handlers)deleteListWith(sock->input_handlers,deleteInputHandler);
   if(sock->input)         deleteListWith(sock->input, free);
   if(sock->command_hist)  deleteListWith(sock->command_hist, free);
@@ -647,6 +642,8 @@
   if(sock_new->page_string)    free(sock_new->page_string);
   if(sock_new->text_editor)    deleteBuffer(sock_new->text_editor);
   if(sock_new->outbuf)         deleteBuffer(sock_new->outbuf);
+  if(sock_new->next_command)   deleteBuffer(sock_new->next_command);
+  if(sock_new->iac_sequence)   deleteBuffer(sock_new->iac_sequence);
   if(sock_new->input_handlers) deleteListWith(sock_new->input_handlers, deleteInputHandler);
   if(sock_new->auxiliary)      deleteAuxiliaryData(sock_new->auxiliary);
   if(sock_new->input)          deleteListWith(sock_new->input, free);
@@ -663,6 +660,8 @@
 
   sock_new->text_editor    = newBuffer(1);
   sock_new->outbuf         = newBuffer(MAX_OUTPUT);
+  sock_new->next_command   = newBuffer(1);
+  sock_new->iac_sequence   = newBuffer(1);
 }
 
 
@@ -864,11 +863,13 @@
       IH_PAIR *pair = listGet(sock->input_handlers, 0);
       if(pair->python == FALSE) {
 	void (* handler)(SOCKET_DATA *, char *) = pair->handler;
-	handler(sock, sock->next_command);
+	char *cmddup = strdup(bufferString(sock->next_command));
+	handler(sock, cmddup);
+	free(cmddup);
       }
       else {
 	PyObject *arglist = Py_BuildValue("Os", socketGetPyFormBorrowed(sock),
-					  sock->next_command);
+					  bufferString(sock->next_command));
 	PyObject *retval  = PyEval_CallObject(pair->handler, arglist);
 
 	// check for an error:
@@ -882,10 +883,10 @@
 
       // append our last command to the command history. History buffer is
       // 100 commands, so pop off the earliest command if we're going over
-      listPut(sock->command_hist, strdup(sock->next_command));
+      listPut(sock->command_hist, strdup(bufferString(sock->next_command)));
       if(listSize(sock->command_hist) > 100)
 	free(listRemoveNum(sock->command_hist, 100));
-      sock->next_command[0] = '\0';
+      bufferClear(sock->next_command);
 
       // we save whether or not we read a command until our next call to
       // input_handler(), at which time it is reset to FALSE if we didn't read
